#import <Foundation/Foundation.h>
#include <CoreAudio/CoreAudioTypes.h>
#include <CoreFoundation/CoreFoundation.h>
#include <AudioUnit/AudioUnitProperties.h>

#define CONVERT_BUFFER_SIZE 1024
typedef int (*AudioCallbackFunction)(float *buffer, int channels, int frames, void *user);

@interface AUStream : NSObject
{
    AURenderCallbackStruct CallbackStruct;
    AudioCallbackFunction CallbackFunction;
    void *refCon;
    float conversionBuffer[CONVERT_BUFFER_SIZE];
}
-(id)initWithCallback:(AudioCallbackFunction)render RefCon:(void*)user SampleRate:(int)sr Channels:(int)chans;
+(id)streamWithCallback:(AudioCallbackFunction)render RefCon:(void*)user SampleRate:(int)sr Channels:(int)chans;
-(BOOL)play;
-(BOOL)stop;
@property (nonatomic) AudioUnit RemoteIO;
@property (nonatomic, readonly) bool started;
@property (nonatomic, readonly) int numChannels;
@property (nonatomic, readonly) int sampleRate;
@end
